﻿@page "/admin/compilers"
@using Microsoft.Extensions.Localization
@using System.Threading
@using Microsoft.EntityFrameworkCore
@using OWebApplication.Operators
@using Sirkadirov.Overtest.SharedLibraries.ODataStoreLib.Models.TasksArchive

@inject AuthenticationStateProvider _authenticationStateProvider
@inject IDbContextFactory<OvertestDatabaseContext> _dbContextFactory
@inject IStringLocalizer<CuratorInvites> _localizer
@inject NavigationManager _navigationManager
@inject UserAccessControlOperator _userAccessControlOperator
@inject UserManager<User> _userManager

@inject IDialogService _dialogService
@inject ISnackbar _snackbar

<MudContainer MaxWidth="MaxWidth.Large" Class="my-3">
    <MudText Typo="Typo.h5" Style="font-weight: bold;">@_localizer["Підтримувані компілятори"]</MudText>
    <MudToolBar Class="px-0 mt-3">
        <MudIconButton Icon="@Icons.Material.Outlined.Add" OnClick="OnCreateNewCompilerButtonClickedAsync" />
        <MudIconButton Icon="@Icons.Material.Outlined.Refresh" OnClick="OnRefreshButtonClickedAsync" />
        @if (_selectedCompilers is not null && _selectedCompilers.Count > 0)
        {
            if (_selectedCompilers.Count == 1)
            {
                <MudIconButton Icon="@Icons.Material.Outlined.Edit" OnClick="OnEditExistingCompilerButtonClickedAsync" />
            }
            <MudIconButton Icon="@Icons.Material.Outlined.Delete" OnClick="RemoveSelectedCompilersAsync" />
        }
        <MudSpacer />
        <MudIconButton Icon="@Icons.Material.Outlined.MoreVert" Disabled="true" />
    </MudToolBar>
</MudContainer>

<MudContainer MaxWidth="MaxWidth.Large" Class="my-3">
    @if (_compilers is null)
    {
        <MudSkeleton SkeletonType="SkeletonType.Rectangle" Width="100%" Height="300px" />
    }
    else if (_compilers.Count <= 0)
    {
        <MudAlert Severity="Severity.Info" Elevation="0">
            @_localizer["У системі ще не зареєстровано жодного підтримуваного компілятора. Додайте перший вже зараз!"]
        </MudAlert>
    }
    else
    {
        <MudTable MultiSelection="true" Hover="true" Items="@_compilers" @bind-SelectedItems="_selectedCompilers">
            <HeaderContent>
                <MudTh>@_localizer["Назва"]</MudTh>
                <MudTh>@_localizer["Статус"]</MudTh>
                <MudTh>@_localizer["Ідентифікатор"]</MudTh>
                <MudTh>@_localizer["Підсвічування синтаксису"]</MudTh>
            </HeaderContent>
            <RowTemplate>
                <MudTd DataLabel="@_localizer["Назва:"]">@context.Title</MudTd>
                <MudTd DataLabel="@_localizer["Статус:"]">
                    @if (context.Enabled)
                    {
                        <MudChip Color="Color.Success">@_localizer["Активний"]</MudChip>
                    }
                    else
                    {
                        <MudChip>@_localizer["Неактивний"]</MudChip>
                    }
                </MudTd>
                <MudTd DataLabel="@_localizer["Ідентифікатор:"]">@context.Id.ToString()</MudTd>
                <MudTd DataLabel="@_localizer["Підсвічування синтаксису:"]">@context.SyntaxHighlighter</MudTd>
            </RowTemplate>
            <FooterContent>
                <MudTd colspan="4">@_localizer["Обрати усі компілятори"]</MudTd>
            </FooterContent>
        </MudTable>
    }
</MudContainer>

@code {
    private SemaphoreSlim _semaphore;
    
    private List<Compiler> _compilers;
    private HashSet<Compiler> _selectedCompilers;

    protected override async Task OnInitializedAsync()
    {
        await base.OnInitializedAsync();
        _semaphore = new SemaphoreSlim(1, 1);

        await _semaphore.WaitAsync();
        try
        {
            await using var databaseContext = _dbContextFactory.CreateDbContext();

            if (!await VerifyCurrentUserPermissionsAsync(databaseContext))
            {
                _snackbar.Add(_localizer["Ви не маєте необхідних прав для доступу до цього сервісу!"],
                    Severity.Error, options => options.CloseAfterNavigation = false);
                _navigationManager.NavigateTo("/");
                // ReSharper disable once RedundantJumpStatement
                return;
            }
            await LoadSupportedCompilersListAsync(databaseContext);
            StateHasChanged();
        }
        finally { _semaphore.Release(); }
        
        // ReSharper disable once VariableHidesOuterVariable
        async Task<bool> VerifyCurrentUserPermissionsAsync(OvertestDatabaseContext databaseContext)
        {
            var authState = await _authenticationStateProvider.GetAuthenticationStateAsync();
            var currentUserId = new Guid(_userManager.GetUserId(authState.User));
            
            return await _userAccessControlOperator.HasUserTypeAsync(
                databaseContext, currentUserId, UserType.SuperUser);
        }
    }
    
    private async Task OnRefreshButtonClickedAsync()
    {
        if (_compilers is null)
            return;
        
        await _semaphore.WaitAsync();
        try
        {
            _compilers = null;
            _selectedCompilers = null;
            StateHasChanged();
            await using var databaseContext = _dbContextFactory.CreateDbContext();
            await LoadSupportedCompilersListAsync(databaseContext);
            StateHasChanged();
        }
        finally { _semaphore.Release(); }
    }
    
    private async Task OnCreateNewCompilerButtonClickedAsync()
    {
        await _dialogService.Show<CompilerEditModalDialog>(null, new DialogParameters
        {
            ["CompilerId"] = null
        }, new DialogOptions
        {
            Position = DialogPosition.Center,
            
            MaxWidth = MaxWidth.Small,
            FullWidth = true,
            
            CloseButton = true,
            DisableBackdropClick = false
        }).Result;

        await OnRefreshButtonClickedAsync();
    }

    private async Task OnEditExistingCompilerButtonClickedAsync()
    {
        if (_selectedCompilers.Count != 1)
            return;
        
        await _dialogService.Show<CompilerEditModalDialog>(null, new DialogParameters
        {
            ["CompilerId"] = _selectedCompilers.First().Id
        }, new DialogOptions
        {
            Position = DialogPosition.Center,
            
            MaxWidth = MaxWidth.Small,
            FullWidth = true,
            
            CloseButton = true,
            DisableBackdropClick = false
        }).Result;

        await OnRefreshButtonClickedAsync();
    }
    
    private async Task LoadSupportedCompilersListAsync(OvertestDatabaseContext databaseContext)
    {
        _selectedCompilers = null;
        _compilers = await databaseContext.Compilers
            .OrderByDescending(order => order.Enabled)
            .ThenBy(order => order.Title)
            .AsNoTracking().ToListAsync();
    }

    private async Task RemoveSelectedCompilersAsync()
    {
        if (_selectedCompilers is null || !_selectedCompilers.Any())
            return;
        
        await _semaphore.WaitAsync();
        try
        {
            await using var databaseContext = _dbContextFactory.CreateDbContext();

            var compilerIdsList = _selectedCompilers.Select(s => s.Id).ToList();
            var dependantTasksCount = await databaseContext.ProgrammingTasks
                .Where(t => compilerIdsList.Contains(t.Id)).CountAsync();

            if (dependantTasksCount > 0)
            {
                _snackbar.Add(_localizer[
                    "Обрані вами компілятори не можуть бути видалені, оскільки від них залежить {0} завдань " +
                    "з \"Архіву завдань системи\". Спочатку видаліть такі завдання, після чого повторіть цю дію.",
                    dependantTasksCount], Severity.Error);
                _selectedCompilers = null;
                StateHasChanged();
                return;
            }
            
            databaseContext.RemoveRange(_selectedCompilers);
            await databaseContext.SaveChangesAsync();

            await LoadSupportedCompilersListAsync(databaseContext);
            StateHasChanged();
        }
        finally { _semaphore.Release(); }
    }
}